--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -19,10 +19,10 @@
  * CDDL HEADER END
  */
 
-/* Copyright 2010 QLogic Corporation */
+/* Copyright 2015 QLogic Corporation */
 
 /*
- * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
  */
 /*
  * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
@@ -29,7 +29,7 @@
  * Copyright (c) 2016 by Delphix. All rights reserved.
  */
 
-#pragma ident	"Copyright 2010 QLogic Corporation; ql_api.c"
+#pragma ident	"Copyright 2015 QLogic Corporation; ql_api.c"
 
 /*
  * ISP2xxx Solaris Fibre Channel Adapter (FCA) driver source file.
@@ -37,7 +37,7 @@
  * ***********************************************************************
  * *									**
  * *				NOTICE					**
- * *		COPYRIGHT (C) 1996-2010 QLOGIC CORPORATION		**
+ * *		COPYRIGHT (C) 1996-2015 QLOGIC CORPORATION		**
  * *			ALL RIGHTS RESERVED				**
  * *									**
  * ***********************************************************************
@@ -54,6 +54,7 @@
 #include <ql_mbx.h>
 #include <ql_nx.h>
 #include <ql_xioctl.h>
+#include <ql_fm.h>
 
 /*
  * Solaris external defines.
@@ -94,20 +95,9 @@
 /*
  * FCA Driver Support Function Prototypes.
  */
-static uint16_t	ql_wait_outstanding(ql_adapter_state_t *);
-static void ql_task_mgmt(ql_adapter_state_t *, ql_tgt_t *, fc_packet_t *,
-    ql_srb_t *);
-static void ql_task_daemon(void *);
-static void ql_task_thread(ql_adapter_state_t *);
-static void ql_unsol_callback(ql_srb_t *);
-static void ql_free_unsolicited_buffer(ql_adapter_state_t *,
-    fc_unsol_buf_t *);
-static void ql_timer(void *);
-static void ql_watchdog(ql_adapter_state_t *, uint32_t *, uint32_t *);
-static void ql_cmd_timeout(ql_adapter_state_t *, ql_tgt_t *q, ql_srb_t *,
-    uint32_t *, uint32_t *);
-static void ql_halt(ql_adapter_state_t *, int);
+static ql_adapter_state_t *ql_cmd_setup(opaque_t, fc_packet_t *, int *);
 static int ql_els_plogi(ql_adapter_state_t *, fc_packet_t *);
+static int ql_p2p_plogi(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_flogi(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_logo(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_prli(ql_adapter_state_t *, fc_packet_t *);
@@ -120,38 +110,49 @@
 static int ql_els_rscn(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_farp_req(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_farp_reply(ql_adapter_state_t *, fc_packet_t *);
-static int ql_els_rls(ql_adapter_state_t *, fc_packet_t *);
 static int ql_els_rnid(ql_adapter_state_t *, fc_packet_t *);
+static int ql_els_rls(ql_adapter_state_t *, fc_packet_t *);
+static int ql_busy_plogi(ql_adapter_state_t *, fc_packet_t *, ql_tgt_t *);
 static int ql_login_port(ql_adapter_state_t *, port_id_t);
 static int ql_login_fabric_port(ql_adapter_state_t *, ql_tgt_t *, uint16_t);
 static int ql_logout_port(ql_adapter_state_t *, port_id_t);
-static ql_lun_t *ql_lun_queue(ql_adapter_state_t *, ql_tgt_t *, uint16_t);
+static ql_lun_t *ql_lun_queue(ql_adapter_state_t *, ql_tgt_t *, uint64_t);
 static int ql_fcp_scsi_cmd(ql_adapter_state_t *, fc_packet_t *, ql_srb_t *);
+static void ql_task_mgmt(ql_adapter_state_t *, ql_tgt_t *, fc_packet_t *,
+    ql_srb_t *);
 static int ql_fcp_ip_cmd(ql_adapter_state_t *, fc_packet_t *, ql_srb_t *);
 static int ql_fc_services(ql_adapter_state_t *, fc_packet_t *);
-static int ql_poll_cmd(ql_adapter_state_t *, ql_srb_t *, time_t);
 static int ql_start_cmd(ql_adapter_state_t *, ql_tgt_t *, fc_packet_t *,
     ql_srb_t *);
-static int ql_kstat_update(kstat_t *, int);
-static ql_adapter_state_t *ql_fca_handle_to_state(opaque_t);
-static ql_adapter_state_t *ql_cmd_setup(opaque_t, fc_packet_t *, int *);
-static int ql_program_flash_address(ql_adapter_state_t *, uint32_t, uint8_t);
-static void ql_rst_aen(ql_adapter_state_t *);
-static void ql_restart_queues(ql_adapter_state_t *);
-static void ql_abort_queues(ql_adapter_state_t *);
-static void ql_abort_device_queues(ql_adapter_state_t *ha, ql_tgt_t *tq);
+static int ql_poll_cmd(ql_adapter_state_t *, ql_srb_t *, time_t);
+static void ql_task_daemon(void *);
+static void ql_task_thread(ql_adapter_state_t *);
 static void ql_idle_check(ql_adapter_state_t *);
-static int ql_loop_resync(ql_adapter_state_t *);
-static size_t ql_24xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
-static size_t ql_2581_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
-static int ql_save_config_regs(dev_info_t *);
-static int ql_restore_config_regs(dev_info_t *);
-static int ql_process_rscn(ql_adapter_state_t *, fc_affected_id_t *);
-static int ql_handle_rscn_update(ql_adapter_state_t *);
+static void ql_unsol_callback(ql_srb_t *);
+static int ql_process_logo_for_device(ql_adapter_state_t *, ql_tgt_t *);
 static int ql_send_plogi(ql_adapter_state_t *, ql_tgt_t *, ql_head_t *);
+static void ql_update_rscn(ql_adapter_state_t *, fc_affected_id_t *);
+static int ql_process_rscn(ql_adapter_state_t *, fc_affected_id_t *);
 static int ql_process_rscn_for_device(ql_adapter_state_t *, ql_tgt_t *);
-static int ql_dump_firmware(ql_adapter_state_t *);
-static int ql_process_logo_for_device(ql_adapter_state_t *, ql_tgt_t *);
+static int ql_handle_rscn_update(ql_adapter_state_t *);
+static void ql_free_unsolicited_buffer(ql_adapter_state_t *,
+    fc_unsol_buf_t *);
+static void ql_timer(void *);
+static void ql_timeout_insert(ql_adapter_state_t *, ql_tgt_t *, ql_srb_t *);
+static void ql_watchdog(ql_adapter_state_t *);
+static void ql_wdg_tq_list(ql_adapter_state_t *, ql_tgt_t *);
+static void ql_cmd_timeout(ql_adapter_state_t *, ql_tgt_t *q, ql_srb_t *);
+static uint16_t	ql_wait_outstanding(ql_adapter_state_t *);
+static void ql_iidma(ql_adapter_state_t *);
+static void ql_abort_device_queues(ql_adapter_state_t *ha, ql_tgt_t *tq);
+static void ql_loop_resync(ql_adapter_state_t *);
+static ql_adapter_state_t *ql_fca_handle_to_state(opaque_t);
+static int ql_kstat_update(kstat_t *, int);
+static int ql_program_flash_address(ql_adapter_state_t *, uint32_t, uint8_t);
+static size_t ql_24xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
+static size_t ql_25xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
+static size_t ql_81xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
+static size_t ql_8021_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
 static int ql_2200_binary_fw_dump(ql_adapter_state_t *, ql_fw_dump_t *);
 static int ql_2300_binary_fw_dump(ql_adapter_state_t *, ql_fw_dump_t *);
 static int ql_24xx_binary_fw_dump(ql_adapter_state_t *, ql_24xx_fw_dump_t *);
@@ -161,33 +162,85 @@
     void *);
 static void *ql_read_regs(ql_adapter_state_t *, void *, void *, uint32_t,
     uint8_t);
-static int ql_busy_plogi(ql_adapter_state_t *, fc_packet_t *, ql_tgt_t *);
-static int ql_suspend_adapter(ql_adapter_state_t *);
-static int ql_bstr_to_dec(char *, uint32_t *, uint32_t);
-static void ql_update_rscn(ql_adapter_state_t *, fc_affected_id_t *);
-int ql_alloc_dma_resouce(ql_adapter_state_t *, dma_mem_t *, int);
+static int ql_save_config_regs(dev_info_t *);
+static int ql_restore_config_regs(dev_info_t *);
+static void ql_halt(ql_adapter_state_t *, int);
 static int ql_bind_dma_buffer(ql_adapter_state_t *, dma_mem_t *, int);
 static void ql_unbind_dma_buffer(ql_adapter_state_t *, dma_mem_t *);
-static void ql_timeout_insert(ql_adapter_state_t *, ql_tgt_t *, ql_srb_t *);
+static int ql_suspend_adapter(ql_adapter_state_t *);
+static int ql_bstr_to_dec(char *, uint32_t *, uint32_t);
 static int ql_setup_interrupts(ql_adapter_state_t *);
 static int ql_setup_msi(ql_adapter_state_t *);
 static int ql_setup_msix(ql_adapter_state_t *);
 static int ql_setup_fixed(ql_adapter_state_t *);
 static void ql_release_intr(ql_adapter_state_t *);
-static void ql_disable_intr(ql_adapter_state_t *);
 static int ql_legacy_intr(ql_adapter_state_t *);
 static int ql_init_mutex(ql_adapter_state_t *);
 static void ql_destroy_mutex(ql_adapter_state_t *);
-static void ql_iidma(ql_adapter_state_t *);
-
-static int ql_n_port_plogi(ql_adapter_state_t *);
-static void ql_fca_isp_els_request(ql_adapter_state_t *, fc_packet_t *,
-    els_descriptor_t *);
+static void ql_fca_isp_els_request(ql_adapter_state_t *, ql_request_q_t *,
+    fc_packet_t *, els_descriptor_t *);
 static void ql_isp_els_request_ctor(els_descriptor_t *,
     els_passthru_entry_t *);
-static int ql_p2p_plogi(ql_adapter_state_t *, fc_packet_t *);
-static int ql_wait_for_td_stop(ql_adapter_state_t *);
-static void ql_process_idc_event(ql_adapter_state_t *);
+static int ql_n_port_plogi(ql_adapter_state_t *);
+static int ql_create_queues(ql_adapter_state_t *);
+static int ql_create_rsp_queue(ql_adapter_state_t *, uint16_t);
+static void ql_delete_queues(ql_adapter_state_t *);
+static int ql_multi_queue_support(ql_adapter_state_t *);
+static int ql_map_mem_bar(ql_adapter_state_t *, ddi_acc_handle_t *, caddr_t *,
+    uint32_t, uint32_t);
+static void ql_completion_thread(void *);
+static void ql_process_comp_queue(void *);
+static int ql_abort_io(ql_adapter_state_t *vha, ql_srb_t *);
+static void ql_idc(ql_adapter_state_t *);
+static int ql_83xx_binary_fw_dump(ql_adapter_state_t *, ql_83xx_fw_dump_t *);
+static size_t ql_83xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
+static caddr_t ql_str_ptr(ql_adapter_state_t *, caddr_t, uint32_t *);
+static int ql_27xx_binary_fw_dump(ql_adapter_state_t *);
+static size_t ql_27xx_ascii_fw_dump(ql_adapter_state_t *, caddr_t);
+static uint32_t ql_2700_dmp_parse_template(ql_adapter_state_t *, ql_dt_hdr_t *,
+    uint8_t *, uint32_t);
+static int ql_2700_dt_riob1(ql_adapter_state_t *, ql_dt_riob1_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_wiob1(ql_adapter_state_t *, ql_dt_wiob1_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_riob2(ql_adapter_state_t *, ql_dt_riob2_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_wiob2(ql_adapter_state_t *, ql_dt_wiob2_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_rpci(ql_adapter_state_t *, ql_dt_rpci_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_wpci(ql_adapter_state_t *, ql_dt_wpci_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_rram(ql_adapter_state_t *, ql_dt_rram_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_gque(ql_adapter_state_t *, ql_dt_gque_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_gfce(ql_adapter_state_t *, ql_dt_gfce_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_prisc(ql_adapter_state_t *, ql_dt_prisc_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_rrisc(ql_adapter_state_t *, ql_dt_rrisc_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_dint(ql_adapter_state_t *, ql_dt_dint_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_ghbd(ql_adapter_state_t *, ql_dt_ghbd_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_scra(ql_adapter_state_t *, ql_dt_scra_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_rrreg(ql_adapter_state_t *, ql_dt_rrreg_t *, uint8_t *,
+    uint8_t *);
+static void ql_2700_dt_wrreg(ql_adapter_state_t *, ql_dt_wrreg_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_rrram(ql_adapter_state_t *, ql_dt_rrram_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_rpcic(ql_adapter_state_t *, ql_dt_rpcic_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_gques(ql_adapter_state_t *, ql_dt_gques_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dt_wdmp(ql_adapter_state_t *, ql_dt_wdmp_t *, uint8_t *,
+    uint8_t *);
+static int ql_2700_dump_ram(ql_adapter_state_t *, uint16_t, uint32_t, uint32_t,
+    uint8_t *);
 
 /*
  * Global data
@@ -196,10 +249,13 @@
 static int	ql_flash_sbus_fpga = 0;
 uint32_t	ql_os_release_level;
 uint32_t	ql_disable_aif = 0;
+uint32_t	ql_disable_intx = 0;
 uint32_t	ql_disable_msi = 0;
 uint32_t	ql_disable_msix = 0;
 uint32_t	ql_enable_ets = 0;
 uint16_t	ql_osc_wait_count = 1000;
+uint32_t	ql_task_cb_dly = 64;
+uint32_t	qlc_disable_load = 0;
 
 /* Timer routine variables. */
 static timeout_id_t	ql_timer_timeout_id = NULL;
@@ -454,13 +510,59 @@
 	0x504	/* nx_risc_int */
 };
 
+/* 2700/8300 register offsets */
+static reg_off_t reg_off_2700_8300 = {
+	0x00,	/* flash_address */
+	0x04,	/* flash_data */
+	0x08,	/* ctrl_status */
+	0x0c,	/* ictrl */
+	0x10,	/* istatus */
+	0xff,	/* semaphore - n/a */
+	0xff,	/* nvram - n/a */
+	0xff,	/* req_in - n/a */
+	0xff,	/* req_out - n/a */
+	0xff,	/* resp_in - n/a */
+	0xff,	/* resp_out - n/a */
+	0x44,	/* risc2host */
+	32,	/* Number of mailboxes */
+
+	/* Mailbox in register offsets 0 - 31 */
+	0x80, 0x82, 0x84, 0x86, 0x88, 0x8a, 0x8c, 0x8e,
+	0x90, 0x92, 0x94, 0x96, 0x98, 0x9a, 0x9c, 0x9e,
+	0xa0, 0xa2, 0xa4, 0xa6, 0xa8, 0xaa, 0xac, 0xae,
+	0xb0, 0xb2, 0xb4, 0xb6, 0xb8, 0xba, 0xbc, 0xbe,
+
+	/* Mailbox out register offsets 0 - 31 */
+	0x80, 0x82, 0x84, 0x86, 0x88, 0x8a, 0x8c, 0x8e,
+	0x90, 0x92, 0x94, 0x96, 0x98, 0x9a, 0x9c, 0x9e,
+	0xa0, 0xa2, 0xa4, 0xa6, 0xa8, 0xaa, 0xac, 0xae,
+	0xb0, 0xb2, 0xb4, 0xb6, 0xb8, 0xba, 0xbc, 0xbe,
+
+	0xff,	/* fpm_diag_config - n/a */
+	0xff,	/* pcr - n/a */
+	0xff,	/* mctr - n/a */
+	0xff,	/* fb_cmd - n/a */
+	0x48,	/* hccr */
+	0x4c,	/* gpiod */
+	0x50,	/* gpioe */
+	0x58,	/* host_to_host_sema - n/a */
+	0xff,	/* pri_req_in - n/a */
+	0xff,	/* pri_req_out - n/a */
+	0xff,	/* atio_req_in - n/a */
+	0xff,	/* atio_req_out - n/a */
+	0x54,	/* io_base_addr */
+	0xff,	/* nx_host_int - n/a */
+	0xff	/* nx_risc_int - n/a */
+};
+
 /* mutex for protecting variables shared by all instances of the driver */
 kmutex_t ql_global_mutex;
 kmutex_t ql_global_hw_mutex;
 kmutex_t ql_global_el_mutex;
+kmutex_t ql_global_timer_mutex;
 
 /* DMA access attribute structure. */
-static ddi_device_acc_attr_t ql_dev_acc_attr = {
+ddi_device_acc_attr_t ql_dev_acc_attr = {
 	DDI_DEVICE_ATTR_V0,
 	DDI_STRUCTURE_LE_ACC,
 	DDI_STRICTORDER_ACC
@@ -467,7 +569,7 @@
 };
 
 /* I/O DMA attributes structures. */
-static ddi_dma_attr_t ql_64bit_io_dma_attr = {
+ddi_dma_attr_t ql_64bit_io_dma_attr = {
 	DMA_ATTR_V0,			/* dma_attr_version */
 	QL_DMA_LOW_ADDRESS,		/* low DMA address range */
 	QL_DMA_HIGH_64BIT_ADDRESS,	/* high DMA address range */
@@ -482,7 +584,7 @@
 	QL_DMA_XFER_FLAGS		/* DMA transfer flags */
 };
 
-static ddi_dma_attr_t ql_32bit_io_dma_attr = {
+ddi_dma_attr_t ql_32bit_io_dma_attr = {
 	DMA_ATTR_V0,			/* dma_attr_version */
 	QL_DMA_LOW_ADDRESS,		/* low DMA address range */
 	QL_DMA_HIGH_32BIT_ADDRESS,	/* high DMA address range */
@@ -497,22 +599,6 @@
 	QL_DMA_XFER_FLAGS		/* DMA transfer flags */
 };
 
-/* Load the default dma attributes */
-static	ddi_dma_attr_t	ql_32fcsm_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_64fcsm_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_32fcsm_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_64fcsm_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_32fcip_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_64fcip_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_32fcip_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_64fcip_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_32fcp_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_64fcp_cmd_dma_attr;
-static	ddi_dma_attr_t	ql_32fcp_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_64fcp_rsp_dma_attr;
-static	ddi_dma_attr_t	ql_32fcp_data_dma_attr;
-static	ddi_dma_attr_t	ql_64fcp_data_dma_attr;
-
 /* Static declarations of cb_ops entry point functions... */
 static struct cb_ops ql_cb_ops = {
 	ql_open,			/* b/c open */
@@ -556,8 +642,10 @@
 /* Mailbox command code to text converter */
 cmd_table_t mbox_cmd_tbl[] = MBOX_CMD_TABLE();
 
-char qlc_driver_version[] = QL_VERSION;
+char ql_driver_version[] = QL_VERSION;
 
+uint32_t ql_log_entries = QL_LOG_ENTRIES;
+
 /*
  * Loadable Driver Interface Structures.
  * Declare and initialize the module configuration section...
@@ -595,6 +683,11 @@
 	uint16_t	w16;
 	int		rval = 0;
 
+	if (qlc_disable_load) {
+		cmn_err(CE_WARN, "%s load disabled", QL_NAME);
+		return (EINVAL);
+	}
+
 	/* Get OS major release level. */
 	for (w16 = 0; w16 < sizeof (utsname.release); w16++) {
 		if (utsname.release[w16] == '.') {
@@ -629,46 +722,14 @@
 		mutex_init(&ql_global_mutex, NULL, MUTEX_DRIVER, NULL);
 		mutex_init(&ql_global_hw_mutex, NULL, MUTEX_DRIVER, NULL);
 		mutex_init(&ql_global_el_mutex, NULL, MUTEX_DRIVER, NULL);
+		mutex_init(&ql_global_timer_mutex, NULL, MUTEX_DRIVER, NULL);
 		rval = mod_install(&modlinkage);
 		if (rval != 0) {
+			mutex_destroy(&ql_global_timer_mutex);
+			mutex_destroy(&ql_global_el_mutex);
 			mutex_destroy(&ql_global_hw_mutex);
 			mutex_destroy(&ql_global_mutex);
-			mutex_destroy(&ql_global_el_mutex);
 			ddi_soft_state_fini(&ql_state);
-		} else {
-			/*EMPTY*/
-			ql_32fcsm_cmd_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcsm_cmd_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcsm_rsp_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcsm_rsp_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcip_cmd_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcip_cmd_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcip_rsp_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcip_rsp_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcp_cmd_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcp_cmd_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcp_rsp_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcp_rsp_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcp_data_dma_attr = ql_32bit_io_dma_attr;
-			ql_64fcp_data_dma_attr = ql_64bit_io_dma_attr;
-			ql_32fcsm_cmd_dma_attr.dma_attr_sgllen =
-			    ql_64fcsm_cmd_dma_attr.dma_attr_sgllen =
-			    QL_FCSM_CMD_SGLLEN;
-			ql_32fcsm_rsp_dma_attr.dma_attr_sgllen =
-			    ql_64fcsm_rsp_dma_attr.dma_attr_sgllen =
-			    QL_FCSM_RSP_SGLLEN;
-			ql_32fcip_cmd_dma_attr.dma_attr_sgllen =
-			    ql_64fcip_cmd_dma_attr.dma_attr_sgllen =
-			    QL_FCIP_CMD_SGLLEN;
-			ql_32fcip_rsp_dma_attr.dma_attr_sgllen =
-			    ql_64fcip_rsp_dma_attr.dma_attr_sgllen =
-			    QL_FCIP_RSP_SGLLEN;
-			ql_32fcp_cmd_dma_attr.dma_attr_sgllen =
-			    ql_64fcp_cmd_dma_attr.dma_attr_sgllen =
-			    QL_FCP_CMD_SGLLEN;
-			ql_32fcp_rsp_dma_attr.dma_attr_sgllen =
-			    ql_64fcp_rsp_dma_attr.dma_attr_sgllen =
-			    QL_FCP_RSP_SGLLEN;
 		}
 	}
 
@@ -701,9 +762,10 @@
 
 	rval = mod_remove(&modlinkage);
 	if (rval == 0) {
+		mutex_destroy(&ql_global_timer_mutex);
+		mutex_destroy(&ql_global_el_mutex);
 		mutex_destroy(&ql_global_hw_mutex);
 		mutex_destroy(&ql_global_mutex);
-		mutex_destroy(&ql_global_el_mutex);
 		ddi_soft_state_fini(&ql_state);
 	}
 
@@ -763,13 +825,13 @@
 	minor = (int)(getminor((dev_t)arg));
 	ha = ddi_get_soft_state(ql_state, minor);
 	if (ha == NULL) {
-		QL_PRINT_2(CE_CONT, "failed, unknown minor=%d\n",
+		QL_PRINT_2(ha, "failed, unknown minor=%d\n",
 		    getminor((dev_t)arg));
 		*resultp = NULL;
 		return (rval);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	switch (cmd) {
 	case DDI_INFO_DEVT2DEVINFO:
@@ -786,7 +848,7 @@
 		break;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -812,12 +874,12 @@
 	off_t			regsize;
 	uint32_t		size;
 	int			rval, *ptr;
-	int			instance;
 	uint_t			progress = 0;
-	char			*buf;
+	char			*buf, taskq_name[32];
 	ushort_t		caps_ptr, cap;
 	fc_fca_tran_t		*tran;
 	ql_adapter_state_t	*ha = NULL;
+	int			instance = ddi_get_instance(dip);
 
 	static char *pmcomps[] = {
 		NULL,
@@ -825,7 +887,7 @@
 		PM_LEVEL_D0_STR,		/* Device ON */
 	};
 
-	QL_PRINT_3(CE_CONT, "(%d): started, cmd=%xh\n",
+	QL_PRINT_3(NULL, "started, instance=%d, cmd=%xh\n",
 	    ddi_get_instance(dip), cmd);
 
 	buf = (char *)(kmem_zalloc(MAXPATHLEN, KM_SLEEP));
@@ -832,9 +894,6 @@
 
 	switch (cmd) {
 	case DDI_ATTACH:
-		/* first get the instance */
-		instance = ddi_get_instance(dip);
-
 		cmn_err(CE_CONT, "!Qlogic %s(%d) FCA Driver v%s\n",
 		    QL_NAME, instance, QL_VERSION);
 
@@ -852,13 +911,6 @@
 			goto attach_failed;
 		}
 
-		/* No support for high-level interrupts */
-		if (ddi_intr_hilevel(dip, 0) != 0) {
-			cmn_err(CE_WARN, "%s(%d): High level interrupt"
-			    " not supported", QL_NAME, instance);
-			goto attach_failed;
-		}
-
 		/* Allocate our per-device-instance structure */
 		if (ddi_soft_state_zalloc(ql_state,
 		    instance) != DDI_SUCCESS) {
@@ -866,7 +918,6 @@
 			    QL_NAME, instance);
 			goto attach_failed;
 		}
-		progress |= QL_SOFT_STATE_ALLOCED;
 
 		ha = ddi_get_soft_state(ql_state, instance);
 		if (ha == NULL) {
@@ -879,18 +930,24 @@
 		ha->hba.base_address = ha;
 		ha->pha = ha;
 
-		if (ql_el_trace_desc_ctor(ha) != DDI_SUCCESS) {
-			cmn_err(CE_WARN, "%s(%d): can't setup el tracing",
-			    QL_NAME, instance);
-			goto attach_failed;
-		}
+		ha->bit32_io_dma_attr = ql_32bit_io_dma_attr;
+		ha->bit64_io_dma_attr = ql_64bit_io_dma_attr;
 
+		(void) ql_el_trace_alloc(ha);
+
+		progress |= QL_SOFT_STATE_ALLOCED;
+
 		/* Get extended logging and dump flags. */
 		ql_common_properties(ha);
 
+		qlc_fm_init(ha);
+		progress |= QL_FCA_INIT_FM;
+
+		ha->io_dma_attr = ha->bit32_io_dma_attr;
+
 		if (strcmp(ddi_driver_name(ddi_get_parent(dip)),
 		    "sbus") == 0) {
-			EL(ha, "%s SBUS card detected", QL_NAME);
+			EL(ha, "%s SBUS card detected\n", QL_NAME);
 			ha->cfg_flags |= CFG_SBUS_CARD;
 		}
 
@@ -897,10 +954,6 @@
 		ha->dev = kmem_zalloc(sizeof (*ha->dev) *
 		    DEVICE_HEAD_LIST_SIZE, KM_SLEEP);
 
-		ha->outstanding_cmds = kmem_zalloc(
-		    sizeof (*ha->outstanding_cmds) * MAX_OUTSTANDING_COMMANDS,
-		    KM_SLEEP);
-
 		ha->ub_array = kmem_zalloc(sizeof (*ha->ub_array) *
 		    QL_UB_LIMIT, KM_SLEEP);
 
@@ -908,7 +961,7 @@
 		    KM_SLEEP);
 
 		(void) ddi_pathname(dip, buf);
-		ha->devpath = kmem_zalloc(strlen(buf)+1, KM_SLEEP);
+		ha->devpath = kmem_zalloc(strlen(buf) + 1, KM_SLEEP);
 		if (ha->devpath == NULL) {
 			EL(ha, "devpath mem alloc failed\n");
 		} else {
@@ -968,7 +1021,7 @@
 				goto attach_failed;
 			} else {
 				ha->pci_bus_addr = ptr[0];
-				ha->function_number = (uint8_t)
+				ha->pci_function_number = (uint8_t)
 				    (ha->pci_bus_addr >> 8 & 7);
 				ddi_prop_free(ptr);
 			}
@@ -997,6 +1050,14 @@
 			 */
 			size = ql_pci_config_get32(ha, PCI_CONF_BASE0) & BIT_0 ?
 			    2 : 1;
+
+			if (qlc_fm_check_acc_handle(ha, ha->pci_handle)
+			    != DDI_FM_OK) {
+				qlc_fm_report_err_impact(ha,
+				    QL_FM_EREPORT_ACC_HANDLE_CHECK);
+				goto attach_failed;
+			}
+
 			if (ddi_dev_regsize(dip, size, &regsize) !=
 			    DDI_SUCCESS ||
 			    ddi_regs_map_setup(dip, size, &ha->iobase,
@@ -1008,6 +1069,13 @@
 			}
 			progress |= QL_REGS_MAPPED;
 
+			if (qlc_fm_check_acc_handle(ha, ha->dev_handle)
+			    != DDI_FM_OK) {
+				qlc_fm_report_err_impact(ha,
+				    QL_FM_EREPORT_ACC_HANDLE_CHECK);
+				goto attach_failed;
+			}
+
 			/*
 			 * We need I/O space mappings for 23xx HBAs for
 			 * loading flash (FCode). The chip has a bug due to
@@ -1030,6 +1098,13 @@
 					goto attach_failed;
 				}
 				progress |= QL_IOMAP_IOBASE_MAPPED;
+
+				if (qlc_fm_check_acc_handle(ha,
+				    ha->iomap_dev_handle) != DDI_FM_OK) {
+					qlc_fm_report_err_impact(ha,
+					    QL_FM_EREPORT_ACC_HANDLE_CHECK);
+					goto attach_failed;
+				}
 			}
 		}
 
@@ -1055,19 +1130,21 @@
 		case 0x6312:
 		case 0x6322:
 			if (ql_pci_config_get8(ha, PCI_CONF_IPIN) == 2) {
-				ha->flags |= FUNCTION_1;
+				ha->function_number = 1;
 			}
-			if ((ha->device_id == 0x6322) ||
-			    (ha->device_id == 0x2322)) {
-				ha->cfg_flags |= CFG_CTRL_6322;
+			if (ha->device_id == 0x2322 ||
+			    ha->device_id == 0x6322) {
+				ha->cfg_flags |= CFG_CTRL_63XX;
 				ha->fw_class = 0x6322;
 				ha->risc_dump_size = QL_6322_FW_DUMP_SIZE;
 			} else {
-				ha->cfg_flags |= CFG_CTRL_2300;
+				ha->cfg_flags |= CFG_CTRL_23XX;
 				ha->fw_class = 0x2300;
 				ha->risc_dump_size = QL_2300_FW_DUMP_SIZE;
 			}
 			ha->reg_off = &reg_off_2300;
+			ha->interrupt_count = 1;
+			ha->osc_max_cnt = 1024;
 			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
 				goto attach_failed;
 			}
@@ -1084,8 +1161,10 @@
 			break;
 
 		case 0x2200:
-			ha->cfg_flags |= CFG_CTRL_2200;
+			ha->cfg_flags |= CFG_CTRL_22XX;
 			ha->reg_off = &reg_off_2200;
+			ha->interrupt_count = 1;
+			ha->osc_max_cnt = 1024;
 			ha->fw_class = 0x2200;
 			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
 				goto attach_failed;
@@ -1109,16 +1188,19 @@
 		case 0x5432:
 		case 0x8432:
 			if (ql_pci_config_get8(ha, PCI_CONF_IPIN) == 2) {
-				ha->flags |= FUNCTION_1;
+				ha->function_number = 1;
 			}
-			ha->cfg_flags |= CFG_CTRL_2422;
+			ha->cfg_flags |= CFG_CTRL_24XX;
 			if (ha->device_id == 0x8432) {
 				ha->cfg_flags |= CFG_CTRL_MENLO;
 			} else {
 				ha->flags |= VP_ENABLED;
+				ha->max_vports = MAX_24_VIRTUAL_PORTS;
 			}
 
 			ha->reg_off = &reg_off_2400_2500;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
 			ha->fw_class = 0x2400;
 			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
 				goto attach_failed;
@@ -1135,64 +1217,153 @@
 		case 0x2522:
 		case 0x2532:
 			if (ql_pci_config_get8(ha, PCI_CONF_IPIN) == 2) {
-				ha->flags |= FUNCTION_1;
+				ha->function_number = 1;
 			}
 			ha->cfg_flags |= CFG_CTRL_25XX;
 			ha->flags |= VP_ENABLED;
-			ha->fw_class = 0x2500;
+			ha->max_vports = MAX_25_VIRTUAL_PORTS;
 			ha->reg_off = &reg_off_2400_2500;
+			ha->mbar_queue_offset = MBAR2_REG_OFFSET;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
+			ha->fw_class = 0x2500;
 			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
 				goto attach_failed;
 			}
 			ha->risc_dump_size = QL_25XX_FW_DUMP_SIZE;
 			ha->fcp_cmd = ql_command_24xx_iocb;
-			ha->ip_cmd = ql_ip_24xx_iocb;
 			ha->ms_cmd = ql_ms_24xx_iocb;
 			ha->els_cmd = ql_els_24xx_iocb;
 			ha->cmd_segs = CMD_TYPE_7_DATA_SEGMENTS;
 			ha->cmd_cont_segs = CONT_TYPE_1_DATA_SEGMENTS;
+			if (ql_multi_queue_support(ha) == QL_SUCCESS) {
+				ha->flags |= MULTI_QUEUE;
+			}
 			break;
 
+		case 0x2031:
+			/* Get queue pointer memory mapped registers */
+			if (ddi_dev_regsize(dip, 3, &regsize) != DDI_SUCCESS ||
+			    ddi_regs_map_setup(dip, 3, &ha->mbar,
+			    0, regsize, &ql_dev_acc_attr,
+			    &ha->mbar_dev_handle) != DDI_SUCCESS) {
+				cmn_err(CE_WARN, "%s(%d): regs_map_setup"
+				    "(mbar) failed", QL_NAME, instance);
+				goto attach_failed;
+			}
+			ha->mbar_size = (uint32_t)regsize;
+
+			if (ha->pci_function_number != 0 &&
+			    ha->pci_function_number != 2) {
+				ha->function_number = 1;
+			}
+			ha->cfg_flags |= CFG_CTRL_83XX;
+			ha->flags |= VP_ENABLED | MULTI_QUEUE;
+			ha->max_vports = MAX_83_VIRTUAL_PORTS;
+			ha->reg_off = &reg_off_2700_8300;
+			ha->mbar_queue_offset = MBAR2_REG_OFFSET;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
+			ha->fw_class = 0x8301fc;
+			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
+				goto attach_failed;
+			}
+			ha->risc_dump_size = QL_83XX_FW_DUMP_SIZE;
+			ha->fcp_cmd = ql_command_24xx_iocb;
+			ha->ms_cmd = ql_ms_24xx_iocb;
+			ha->els_cmd = ql_els_24xx_iocb;
+			ha->cmd_segs = CMD_TYPE_7_DATA_SEGMENTS;
+			ha->cmd_cont_segs = CONT_TYPE_1_DATA_SEGMENTS;
+			break;
+
+		case 0x2071:
+		case 0x2261:
+		case 0x2271:
+			/* Get queue pointer memory mapped registers */
+			if (ddi_dev_regsize(dip, 3, &regsize) != DDI_SUCCESS ||
+			    ddi_regs_map_setup(dip, 3, &ha->mbar,
+			    0, regsize, &ql_dev_acc_attr,
+			    &ha->mbar_dev_handle) != DDI_SUCCESS) {
+				cmn_err(CE_WARN, "%s(%d): regs_map_setup"
+				    "(mbar) failed", QL_NAME, instance);
+				goto attach_failed;
+			}
+			ha->mbar_size = (uint32_t)regsize;
+
+			ha->function_number = ha->pci_function_number;
+			ha->cfg_flags |= CFG_CTRL_27XX;
+			ha->flags |= VP_ENABLED | MULTI_QUEUE |
+			    QUEUE_SHADOW_PTRS;
+			ha->max_vports = MAX_27_VIRTUAL_PORTS;
+			ha->reg_off = &reg_off_2700_8300;
+			ha->mbar_queue_offset = MBAR2_REG_OFFSET;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
+			ha->fw_class = 0x2700;
+			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
+				goto attach_failed;
+			}
+			ha->risc_dump_size = QL_27XX_FW_DUMP_SIZE;
+			ha->fcp_cmd = ql_command_24xx_iocb;
+			ha->ms_cmd = ql_ms_24xx_iocb;
+			ha->els_cmd = ql_els_24xx_iocb;
+			ha->cmd_segs = CMD_TYPE_7_DATA_SEGMENTS;
+			ha->cmd_cont_segs = CONT_TYPE_1_DATA_SEGMENTS;
+			break;
+
 		case 0x8001:
 			if (ql_pci_config_get8(ha, PCI_CONF_IPIN) == 4) {
-				ha->flags |= FUNCTION_1;
+				ha->function_number = 1;
 			}
 			ha->cfg_flags |= CFG_CTRL_81XX;
 			ha->flags |= VP_ENABLED;
-			ha->fw_class = 0x8100;
+			ha->max_vports = MAX_81XX_VIRTUAL_PORTS;
 			ha->reg_off = &reg_off_2400_2500;
+			ha->mbar_queue_offset = MBAR2_REG_OFFSET;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
+			ha->fw_class = 0x8100;
 			if (ql_fwmodule_resolve(ha) != QL_SUCCESS) {
 				goto attach_failed;
 			}
-			ha->risc_dump_size = QL_25XX_FW_DUMP_SIZE;
+			ha->risc_dump_size = QL_81XX_FW_DUMP_SIZE;
 			ha->fcp_cmd = ql_command_24xx_iocb;
-			ha->ip_cmd = ql_ip_24xx_iocb;
 			ha->ms_cmd = ql_ms_24xx_iocb;
 			ha->cmd_segs = CMD_TYPE_7_DATA_SEGMENTS;
 			ha->cmd_cont_segs = CONT_TYPE_1_DATA_SEGMENTS;
+			if (ql_multi_queue_support(ha) == QL_SUCCESS) {
+				ha->flags |= MULTI_QUEUE;
+			}
 			break;
 
 		case 0x8021:
-			if (ha->function_number & BIT_0) {
-				ha->flags |= FUNCTION_1;
+			if (ha->pci_function_number & BIT_0) {
+				ha->function_number = 1;
 			}
-			ha->cfg_flags |= CFG_CTRL_8021;
+			ha->cfg_flags |= CFG_CTRL_82XX;
+			ha->flags |= VP_ENABLED;
+			ha->max_vports = MAX_8021_VIRTUAL_PORTS;
 			ha->reg_off = &reg_off_8021;
+			ha->interrupt_count = 2;
+			ha->osc_max_cnt = 2048;
 			ha->risc_dump_size = QL_25XX_FW_DUMP_SIZE;
 			ha->fcp_cmd = ql_command_24xx_iocb;
 			ha->ms_cmd = ql_ms_24xx_iocb;
 			ha->cmd_segs = CMD_TYPE_7_DATA_SEGMENTS;
 			ha->cmd_cont_segs = CONT_TYPE_1_DATA_SEGMENTS;
+			ha->io_dma_attr.dma_attr_flags |=
+			    DDI_DMA_RELAXED_ORDERING;
 
 			ha->nx_pcibase = ha->iobase;
-			ha->iobase += 0xBC000 + (ha->function_number << 11);
+			ha->iobase += 0xBC000 + (ha->pci_function_number << 11);
 			ha->iomap_iobase += 0xBC000 +
-			    (ha->function_number << 11);
+			    (ha->pci_function_number << 11);
 
 			/* map doorbell */
 			if (ddi_dev_regsize(dip, 2, &regsize) != DDI_SUCCESS ||
 			    ddi_regs_map_setup(dip, 2, &ha->db_iobase,
-			    0, regsize, &ql_dev_acc_attr, &ha->db_dev_handle) !=
+			    0, regsize, &ql_dev_acc_attr,
+			    &ha->db_dev_handle) !=
 			    DDI_SUCCESS) {
 				cmn_err(CE_WARN, "%s(%d): regs_map_setup"
 				    "(doorbell) failed", QL_NAME, instance);
@@ -1200,10 +1371,17 @@
 			}
 			progress |= QL_DB_IOBASE_MAPPED;
 
+			if (qlc_fm_check_acc_handle(ha, ha->db_dev_handle)
+			    != DDI_FM_OK) {
+				qlc_fm_report_err_impact(ha,
+				    QL_FM_EREPORT_ACC_HANDLE_CHECK);
+				goto attach_failed;
+			}
+
 			ha->nx_req_in = (uint32_t *)(ha->db_iobase +
-			    (ha->function_number << 12));
+			    (ha->pci_function_number << 12));
 			ha->db_read = ha->nx_pcibase + (512 * 1024) +
-			    (ha->function_number * 8);
+			    (ha->pci_function_number * 8);
 
 			ql_8021_update_crb_int_ptr(ha);
 			ql_8021_set_drv_active(ha);
@@ -1215,15 +1393,21 @@
 			goto attach_failed;
 		}
 
-		/* Setup hba buffer. */
+		ha->outstanding_cmds = kmem_zalloc(
+		    sizeof (*ha->outstanding_cmds) * ha->osc_max_cnt,
+		    KM_SLEEP);
 
-		size = CFG_IST(ha, CFG_CTRL_24258081) ?
-		    (REQUEST_QUEUE_SIZE + RESPONSE_QUEUE_SIZE) :
-		    (REQUEST_QUEUE_SIZE + RESPONSE_QUEUE_SIZE +
-		    RCVBUF_QUEUE_SIZE);
+		/* Setup interrupts */
+		if ((rval = ql_setup_interrupts(ha)) != DDI_SUCCESS) {
+			cmn_err(CE_WARN, "%s(%d): Failed to add interrupt, "
+			    "rval=%xh", QL_NAME, instance, rval);
+			goto attach_failed;
+		}
 
-		if (ql_get_dma_mem(ha, &ha->hba_buf, size, LITTLE_ENDIAN_DMA,
-		    QL_DMA_RING_ALIGN) != QL_SUCCESS) {
+		progress |= (QL_INTR_ADDED | QL_MUTEX_CV_INITED);
+
+		/* Setup hba buffer. */
+		if (ql_create_queues(ha) != QL_SUCCESS) {
 			cmn_err(CE_WARN, "%s(%d): request queue DMA memory "
 			    "alloc failed", QL_NAME, instance);
 			goto attach_failed;
